import { ref as x, defineComponent as m, openBlock as c, createElementBlock as u, Fragment as y, renderSlot as b, onMounted as M, nextTick as P, createVNode as $, createSlots as R, withCtx as A, createElementVNode as n, unref as i, pushScopeId as L, popScopeId as k, getCurrentInstance as F, createBlock as O, normalizeProps as V, mergeProps as E, normalizeClass as C, createTextVNode as W, toDisplayString as G, withDirectives as T, vShow as S, computed as J } from "vue";
import { createHighlighter as Q } from "shiki";
const U = /document\.addEventListener\s*\(\s*['"]DOMContentLoaded['"]\s*,\s*(function\s*\([^)]*\)\s*\{|\([^)]*\)\s*=>\s*\{)([\s\S]*?(\{[\s\S]*?\}[\s\S]*?)*)\}\s*\);?\s*|document\.addEventListener\s*\(\s*['"]DOMContentLoaded['"]\s*,\s*(\w+)\s*\);?\s*/;
function H() {
  const o = x("");
  async function t(e, s) {
    const r = await Q({
      langs: [],
      themes: Object.values(s)
    });
    await r.loadLanguage("templ"), o.value = r.codeToHtml(e, {
      lang: "templ",
      themes: s,
      defaultColor: !1
    });
  }
  return {
    highlightedCode: o,
    highlightCode: t
  };
}
function B() {
  const o = document.querySelector(
    ".preview-content"
  );
  o && (new MutationObserver((e) => {
    e.forEach((s) => {
      s.type === "childList" && K(s.target);
    });
  }).observe(o, { childList: !0, subtree: !0 }), K(o));
}
function K(o) {
  o.querySelectorAll("script").forEach((e) => {
    e.getAttribute("data-executed") || (e.textContent && X(e.textContent), e.setAttribute("data-executed", "true"));
  });
}
function X(o) {
  const t = U.exec(o);
  if (t) {
    const e = o.replace(t[0], "").trim();
    if (e && f(e), t[2]) {
      const s = t[2].trim();
      f(`(function() { ${s} })();`);
    } else if (t[4]) {
      const s = t[4].trim();
      f(`${s}();`);
    }
  } else
    f(o);
}
function f(o) {
  var e;
  const t = document.createElement("script");
  t.setAttribute("data-executed", "true"), t.textContent = o, (e = document.body.appendChild(t).parentNode) == null || e.removeChild(t);
}
const Y = /* @__PURE__ */ m({
  __name: "ConditionalWrapper",
  props: {
    isPreviewFirst: { type: Boolean }
  },
  setup(o) {
    const t = o;
    return (e, s) => (c(), u("div", null, [
      t.isPreviewFirst ? (c(), u(y, { key: 0 }, [
        b(e.$slots, "preview"),
        b(e.$slots, "code")
      ], 64)) : (c(), u(y, { key: 1 }, [
        b(e.$slots, "code"),
        b(e.$slots, "preview")
      ], 64))
    ]));
  }
}), Z = (o) => (L("data-v-1007a4b5"), o = o(), k(), o), ee = { class: "container" }, te = { class: "preview" }, oe = ["innerHTML"], ne = { class: "code-content" }, se = { class: "language-templ vp-adaptive-theme" }, ie = /* @__PURE__ */ Z(() => /* @__PURE__ */ n("button", {
  title: "Copy Code",
  class: "copy"
}, null, -1)), ae = /* @__PURE__ */ Z(() => /* @__PURE__ */ n("span", { class: "lang" }, "templ", -1)), le = ["innerHTML"], ce = /* @__PURE__ */ m({
  __name: "VTPCard",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(o) {
    const t = o, { highlightedCode: e, highlightCode: s } = H();
    return M(async () => {
      await s(t.codeContent, t.themes), P(() => {
        B();
      });
    }), (r, p) => (c(), u("div", ee, [
      $(Y, {
        isPreviewFirst: t.isPreviewFirst
      }, R({
        preview: A(() => [
          n("div", te, [
            n("div", {
              class: "preview-content",
              innerHTML: t.htmlContent
            }, null, 8, oe)
          ])
        ]),
        _: 2
      }, [
        t.isPreviewOnly ? void 0 : {
          name: "code",
          fn: A(() => [
            n("div", ne, [
              n("div", se, [
                ie,
                ae,
                n("span", {
                  class: "vp-code",
                  innerHTML: i(e)
                }, null, 8, le)
              ])
            ])
          ]),
          key: "0"
        }
      ]), 1032, ["isPreviewFirst"])
    ]));
  }
}), I = (o, t) => {
  const e = o.__vccOpts || o;
  for (const [s, r] of t)
    e[s] = r;
  return e;
}, z = /* @__PURE__ */ I(ce, [["__scopeId", "data-v-1007a4b5"]]), re = ["width", "height", "fill"], de = /* @__PURE__ */ n("path", {
  "fill-rule": "evenodd",
  d: "M4.78 4.97a.75.75 0 0 1 0 1.06L2.81 8l1.97 1.97a.75.75 0 1 1-1.06 1.06l-2.5-2.5a.75.75 0 0 1 0-1.06l2.5-2.5a.75.75 0 0 1 1.06 0ZM11.22 4.97a.75.75 0 0 0 0 1.06L13.19 8l-1.97 1.97a.75.75 0 1 0 1.06 1.06l2.5-2.5a.75.75 0 0 0 0-1.06l-2.5-2.5a.75.75 0 0 0-1.06 0ZM8.856 2.008a.75.75 0 0 1 .636.848l-1.5 10.5a.75.75 0 0 1-1.484-.212l1.5-10.5a.75.75 0 0 1 .848-.636Z",
  "clip-rule": "evenodd"
}, null, -1), pe = [
  de
], N = /* @__PURE__ */ m({
  __name: "CodeIcon",
  props: {
    fill: {},
    size: { default: 16 }
  },
  setup(o) {
    const t = o;
    return (e, s) => (c(), u("svg", {
      xmlns: "http://www.w3.org/2000/svg",
      width: t.size,
      height: t.size,
      viewBox: "0 0 16 16",
      fill: t.fill,
      "aria-hidden": "true"
    }, pe, 8, re));
  }
}), D = (o) => (L("data-v-36a93aea"), o = o(), k(), o), ue = {
  key: 1,
  class: "container"
}, ve = { class: "preview" }, he = ["innerHTML"], _e = { class: "code-section" }, we = ["aria-controls"], be = ["id", "aria-hidden"], me = { class: "language-templ vp-adaptive-theme" }, ge = /* @__PURE__ */ D(() => /* @__PURE__ */ n("button", {
  title: "Copy Code",
  class: "copy"
}, null, -1)), Ce = /* @__PURE__ */ D(() => /* @__PURE__ */ n("span", { class: "lang" }, "templ", -1)), fe = ["innerHTML"], ye = /* @__PURE__ */ m({
  __name: "VTPCodeToggle",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(o) {
    const t = o, e = x(!1), { highlightedCode: s, highlightCode: r } = H(), p = F(), a = p ? p.uid.toString() : Math.random().toString(36).substring(2, 11);
    function h() {
      e.value = !e.value;
    }
    return M(async () => {
      await r(t.codeContent, t.themes), P(() => {
        B();
      });
    }), (_, l) => t.isPreviewOnly ? (c(), O(z, V(E({ key: 0 }, t)), null, 16)) : (c(), u("div", ue, [
      n("div", ve, [
        n("div", {
          class: "preview-content",
          innerHTML: t.htmlContent
        }, null, 8, he)
      ]),
      n("div", _e, [
        n("button", {
          onClick: h,
          class: C(`button-${t.buttonStyle}`),
          "aria-controls": "code-content-" + i(a),
          "aria-label": "view the source code"
        }, [
          b(_.$slots, "code-icon", {}, () => [
            $(N, {
              fill: `var(--vp-button-${t.buttonStyle}-text)`
            }, null, 8, ["fill"])
          ], !0),
          W(" " + G(e.value ? "Hide Code" : "Show Code"), 1)
        ], 10, we),
        n("div", {
          class: "code-content",
          id: "code-content-" + i(a),
          "aria-hidden": !e.value
        }, [
          n("div", null, [
            n("div", me, [
              ge,
              Ce,
              n("span", {
                class: "vp-code",
                innerHTML: i(s)
              }, null, 8, fe)
            ])
          ])
        ], 8, be)
      ])
    ]));
  }
}), et = /* @__PURE__ */ I(ye, [["__scopeId", "data-v-36a93aea"]]), q = (o) => (L("data-v-9113b9ff"), o = o(), k(), o), $e = { class: "wrapper" }, Te = {
  class: "tabs",
  role: "tablist"
}, Se = ["id", "aria-selected", "aria-controls"], xe = ["id", "aria-selected", "aria-controls"], Me = ["id"], Pe = ["innerHTML"], Le = { class: "code-content" }, ke = { class: "language-templ vp-adaptive-theme" }, He = /* @__PURE__ */ q(() => /* @__PURE__ */ n("button", {
  title: "Copy Code",
  class: "copy"
}, null, -1)), Be = /* @__PURE__ */ q(() => /* @__PURE__ */ n("span", { class: "lang" }, "templ", -1)), Ie = ["innerHTML"], Fe = /* @__PURE__ */ m({
  __name: "VTPTabs",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(o) {
    const t = o, e = x("preview"), { highlightedCode: s, highlightCode: r } = H(), p = F(), a = p ? p.uid.toString() : Math.random().toString(36).substring(2, 11), h = (_, l) => {
      (_.key === "Enter" || _.key === " ") && (e.value = l);
    };
    return M(async () => {
      await r(t.codeContent, t.themes), P(() => {
        B();
      });
    }), (_, l) => t.isPreviewOnly ? (c(), O(z, V(E({ key: 0 }, t)), null, 16)) : (c(), u(y, { key: 1 }, [
      n("div", $e, [
        n("div", Te, [
          n("button", {
            role: "tab",
            id: "tab-preview-" + i(a),
            "aria-selected": e.value === "preview",
            class: C({ active: e.value === "preview" }),
            onClick: l[0] || (l[0] = (v) => e.value = "preview"),
            onKeydown: l[1] || (l[1] = (v) => h(v, "preview")),
            tabindex: "0",
            "aria-controls": "tabpanel-preview-" + i(a),
            "aria-label": "preview the component"
          }, " Preview ", 42, Se),
          n("button", {
            role: "tab",
            id: "tab-code-" + i(a),
            "aria-selected": e.value === "code",
            class: C({ active: e.value === "code" }),
            onClick: l[2] || (l[2] = (v) => e.value = "code"),
            onKeydown: l[3] || (l[3] = (v) => h(v, "code")),
            tabindex: "0",
            "aria-controls": "tabpanel-code-" + i(a),
            "aria-label": "view the source code"
          }, " Code ", 42, xe)
        ])
      ]),
      n("div", {
        class: "tab-content",
        role: "tabpanel",
        id: "tabpanel-" + e.value + "-" + i(a)
      }, [
        T(n("div", {
          class: "preview-content",
          innerHTML: t.htmlContent
        }, null, 8, Pe), [
          [S, e.value === "preview"]
        ]),
        T(n("div", Le, [
          n("div", ke, [
            He,
            Be,
            n("span", {
              class: "vp-code",
              innerHTML: i(s)
            }, null, 8, Ie)
          ])
        ], 512), [
          [S, e.value === "code"]
        ])
      ], 8, Me)
    ], 64));
  }
}), tt = /* @__PURE__ */ I(Fe, [["__scopeId", "data-v-9113b9ff"]]), Oe = ["width", "height", "fill"], Ve = /* @__PURE__ */ n("path", { d: "M8 9.5a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3Z" }, null, -1), Ee = /* @__PURE__ */ n("path", {
  "fill-rule": "evenodd",
  d: "M1.38 8.28a.87.87 0 0 1 0-.566 7.003 7.003 0 0 1 13.238.006.87.87 0 0 1 0 .566A7.003 7.003 0 0 1 1.379 8.28ZM11 8a3 3 0 1 1-6 0 3 3 0 0 1 6 0Z",
  "clip-rule": "evenodd"
}, null, -1), ze = [
  Ve,
  Ee
], Ae = /* @__PURE__ */ m({
  __name: "ViewIcon",
  props: {
    fill: {},
    size: { default: 16 }
  },
  setup(o) {
    const t = o;
    return (e, s) => (c(), u("svg", {
      xmlns: "http://www.w3.org/2000/svg",
      width: t.size,
      height: t.size,
      viewBox: "0 0 16 16",
      fill: t.fill,
      "aria-hidden": "true"
    }, ze, 8, Oe));
  }
}), j = (o) => (L("data-v-567cab52"), o = o(), k(), o), Ke = { class: "wrapper" }, Ze = {
  class: "tabs",
  role: "tablist"
}, Ne = ["id", "aria-selected", "aria-controls"], De = ["id", "aria-selected", "aria-controls"], qe = ["id"], je = ["innerHTML"], Re = { class: "code-content" }, We = { class: "language-templ vp-adaptive-theme" }, Ge = /* @__PURE__ */ j(() => /* @__PURE__ */ n("button", {
  title: "Copy Code",
  class: "copy"
}, null, -1)), Je = /* @__PURE__ */ j(() => /* @__PURE__ */ n("span", { class: "lang" }, "templ", -1)), Qe = ["innerHTML"], Ue = /* @__PURE__ */ m({
  __name: "VTPIconTabs",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(o) {
    const t = o, e = x("preview"), { highlightedCode: s, highlightCode: r } = H(), p = F(), a = p ? p.uid.toString() : Math.random().toString(36).substring(2, 11), h = (w) => J(() => e.value === w ? "var(--vp-button-brand-text)" : "var(--vp-button-alt-text)"), _ = h("preview"), l = h("code"), v = (w, d) => {
      (w.key === "Enter" || w.key === " ") && (e.value = d);
    };
    return M(async () => {
      await r(t.codeContent, t.themes), P(() => {
        B();
      });
    }), (w, d) => t.isPreviewOnly ? (c(), O(z, V(E({ key: 0 }, t)), null, 16)) : (c(), u(y, { key: 1 }, [
      n("div", Ke, [
        n("div", Ze, [
          n("button", {
            role: "tab",
            id: "tab-preview-" + i(a),
            "aria-selected": e.value === "preview",
            class: C({ active: e.value === "preview" }),
            onClick: d[0] || (d[0] = (g) => e.value = "preview"),
            onKeydown: d[1] || (d[1] = (g) => v(g, "preview")),
            tabindex: "0",
            "aria-controls": "tabpanel-preview-" + i(a),
            "aria-label": "preview the component"
          }, [
            b(w.$slots, "preview-icon", {}, () => [
              $(Ae, { fill: i(_) }, null, 8, ["fill"])
            ], !0)
          ], 42, Ne),
          n("button", {
            role: "tab",
            id: "tab-code-" + i(a),
            "aria-selected": e.value === "code",
            class: C({ active: e.value === "code" }),
            onClick: d[2] || (d[2] = (g) => e.value = "code"),
            onKeydown: d[3] || (d[3] = (g) => v(g, "code")),
            tabindex: "0",
            "aria-controls": "tabpanel-code-" + i(a),
            "aria-label": "view the source code"
          }, [
            b(w.$slots, "code-icon", {}, () => [
              $(N, { fill: i(l) }, null, 8, ["fill"])
            ], !0)
          ], 42, De)
        ])
      ]),
      n("div", {
        class: "tab-content",
        role: "tabpanel",
        id: "tabpanel-" + e.value + "-" + i(a)
      }, [
        T(n("div", {
          class: "preview-content",
          innerHTML: t.htmlContent
        }, null, 8, je), [
          [S, e.value === "preview"]
        ]),
        T(n("div", Re, [
          n("div", We, [
            Ge,
            Je,
            n("span", {
              class: "vp-code",
              innerHTML: i(s)
            }, null, 8, Qe)
          ])
        ], 512), [
          [S, e.value === "code"]
        ])
      ], 8, qe)
    ], 64));
  }
}), ot = /* @__PURE__ */ I(Ue, [["__scopeId", "data-v-567cab52"]]);
export {
  z as VTPCard,
  et as VTPCodeToggle,
  ot as VTPIconTabs,
  tt as VTPTabs
};
